<div id="top"></div>
<!--
*** Thanks for checking out the Best-README-Template. If you have a suggestion
*** that would make this better, please fork the repo and create a pull request
*** or simply open an issue with the tag "enhancement".
*** Don't forget to give the project a star!
*** Thanks again! Now go create something AMAZING! :D
-->



<!-- PROJECT SHIELDS -->
<!--
*** I'm using markdown "reference style" links for readability.
*** Reference links are enclosed in brackets [ ] instead of parentheses ( ).
*** See the bottom of this document for the declaration of the reference variables
*** for contributors-url, forks-url, etc. This is an optional, concise syntax you may use.
*** https://www.markdownguide.org/basic-syntax/#reference-style-links
-->
[![Contributors][contributors-shield]][contributors-url]
[![Forks][forks-shield]][forks-url]
[![Stargazers][stars-shield]][stars-url]
[![Issues][issues-shield]][issues-url]


<!-- PROJECT LOGO -->
<!--<br />
<div align="center">
  <a href="https://github.com/ilovefuud/titanium">
    <img src="images/logo.png" alt="Logo" width="80" height="80">
  </a> -->

<h3 align="center">Titanium</h3>

  <p align="center">
    Titanium is a plugin meant to block harmful packets before they're received by the Minecraft packet handler.
    <br />
    <a href="https://github.com/ilovefuud/titanium/issues">Report Bug</a>
    ·
    <a href="https://github.com/ilovefuud/titanium/issues">Request Feature</a>
  </p>
</div>



<!-- TABLE OF CONTENTS -->
<details>
  <summary>Table of Contents</summary>
  <ol>
    <li>
      <a href="#about-the-project">About The Project</a>
      <ul>
        <li><a href="#built-with">Built With</a></li>
      </ul>
    </li>
    <li>
      <a href="#getting-started">Getting Started</a>
      <ul>
        <li><a href="#prerequisites">Prerequisites</a></li>
        <li><a href="#installation">Installation</a></li>
      </ul>
    </li>
    <li><a href="#contributing">Contributing</a></li>
    <li><a href="#license">License</a></li>
    <li><a href="#contact">Contact</a></li>
  </ol>
</details>



<!-- ABOUT THE PROJECT -->
## About The Project

### Built With

* [JDK 17](https://www.oracle.com/java/technologies/javase/jdk17-archive-downloads.html)
* [PacketEvents 2.0](https://github.com/retrooper/packetevents/tree/2.0)

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- GETTING STARTED -->
## Getting Started

To get Titanium up and running on your server follow these simple steps.

### Prerequisites
Titanium supports Spigot 1.8.8 - Latest (1.19). It requires the latest development builds of [ViaVersion](https://ci.viaversion.com/job/ViaVersion-DEV/) and [ProtocolLib 5.0](https://ci.dmulloy2.net/job/ProtocolLib/com.comphenix.protocol$ProtocolLib/) 
if you're using either of those plugins.

### Installation

1. Get the latest version from [releases](https://github.com/ilovefuud/Titanium/releases)
2. Put the file in your Spigot/Paper server's plugin folder.
3. Start your server to load the default config.
4. Modify the config to your preferences, although the default config will work for 99% of servers.
5. Your all set! Make sure you have the permission "titanium.notification" in order to receive crash alerts!

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- CONTRIBUTING -->
## Contributing

Contributions are what make the open source community such an amazing place to learn, inspire, and create. Any contributions you make are **greatly appreciated**.

If you have a suggestion that would make this better, please fork the repo and create a pull request. You can also simply open an issue with the tag "enhancement".
Don't forget to give the project a star! Thanks again!

1. Fork the Project
2. Create your Feature Branch (`git checkout -b feature/AmazingFeature`)
3. Commit your Changes (`git commit -m 'Add some AmazingFeature'`)
4. Push to the Branch (`git push origin feature/AmazingFeature`)
5. Open a Pull Request

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- LICENSE -->
## License

Distributed under the GNU GPL License. See `LICENSE.txt` for more information.

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- CONTACT -->
## Contact

Discord - [@jt#1296](http://discord.strafe.us)

Project Link: [https://github.com/ilovefuud/titanium](https://github.com/ilovefuud/titanium)

<p align="right">(<a href="#top">back to top</a>)</p>



<!-- MARKDOWN LINKS & IMAGES -->
<!-- https://www.markdownguide.org/basic-syntax/#reference-style-links -->
[contributors-shield]: https://img.shields.io/github/contributors/ilovefuud/titanium.svg?style=for-the-badge
[contributors-url]: https://github.com/ilovefuud/titanium/graphs/contributors
[forks-shield]: https://img.shields.io/github/forks/ilovefuud/titanium.svg?style=for-the-badge
[forks-url]: https://github.com/ilovefuud/titanium/network/members
[stars-shield]: https://img.shields.io/github/stars/ilovefuud/titanium.svg?style=for-the-badge
[stars-url]: https://github.com/ilovefuud/titanium/stargazers
[issues-shield]: https://img.shields.io/github/issues/ilovefuud/titanium.svg?style=for-the-badge
[issues-url]: https://github.com/ilovefuud/titanium/issues
[license-shield]: https://img.shields.io/github/license/ilovefuud/titanium.svg?style=for-the-badge
[license-url]: https://github.com/ilovefuud/titanium/blob/master/LICENSE.txt
[product-screenshot]: images/screenshot.png
